/**********************************************************************
 * SimMips: Simple Computer Simulator of MIPS                         *
 * Copyright (C) 2008-2010 Arch Lab. Tokyo Institute of Technology    *
 *  Dual licensed under New BSD or GPL v2 licenses.                   *
 *  See COPYING file on the base directory for more information.      *
 **********************************************************************/
#include "../core/define.h"
#include "../common/ttyc.h"
#define L_NAME_ME "MieruEmb Extension"
#define L_VER_ME  "2010-11-02"

/**********************************************************************/
class DisplayControllerME : public MMDevice {
 private:
    char *cmdbuf;
    int gui_pipe;
    int lcd_size;

 public:
    ~DisplayControllerME();
    void init(Board *);
    int write(const uint032_t, uint, uint064_t);
};  

/**********************************************************************/
class MieruIOME : public MMDevice {
 private:
    Board *board;

public:
    void init(Board *);
    int read(const uint032_t, uint, void*);
};

/**********************************************************************/
class BoardME : public Board {
 protected:
    ttyControl *ttyc;

    virtual void usage();
    int checkopt(char **argv, int *index);
    virtual MMDevice *setmmdevice(char *, uint032_t);

 public:
    char *lcd_path;
    int lcd_size;

    BoardME();
    virtual ~BoardME() {};
    virtual void versioninfo();
};

/**********************************************************************/
